// mainp3.cc
#include "p3.h"
#include <iostream>

// -- Funciones conectadas a señales --------------------------------------

// Prueba a eliminar el atributo [[maybe_unused]] del parametro row y observa que
// ocurre si comentas la instrucción cout y recompilas.
void show_out_map_attempt([[maybe_unused]] int32_t row, int32_t col) {
  cout << "The robot has attempted to go out from the map [" << row << "," << col << "]"<< endl;
}

void show_obstacle_sensor_attempt([[maybe_unused]] uint32_t row, uint32_t col) {
  cout << "Obstacle detected in [" << row << "," << col << "]\n";
}

void show_low_battery_info([[maybe_unused]] uint16_t battery_level) {
  cout << "Low battery: " << battery_level << "%" << endl;
}

int main() {
    // Conexión de las señales
    auto cout_map_id = get_out_map_signal().connect(show_out_map_attempt);
    auto cobstacle_sensor_id = get_obstacle_signal().connect(show_obstacle_sensor_attempt);
    auto cbattery_id = get_battery_signal().connect(show_low_battery_info);

    // Descomenta la siguiente linea y observa que ocurre al recompilar y ejecutar
    // cobstacle_id.disconnect();

    // Crear el tablero
    Position starting_pos_robot = {2,2};
    Map map = createMap(5, 5, starting_pos_robot);
    placeObstacle(map, {1, 1});
    placeObstacle(map, {3, 3});
    displayMap(map);

    // Mueve el robot y muestra la nueva posición
    moveRobot(map, RIGHT);
    displayMap(map);

    moveRobot(map, DOWN);
    displayMap(map);

    moveRobot(map, DOWN);
    displayMap(map);

    moveRobot(map, RIGHT);
    displayMap(map);

    moveRobot(map, LEFT);
    displayMap(map);

    //Probamos la función de mover una serie de movimientos secuenciales.
    vector<Direction> movements;
    movements.push_back(RIGHT);
    movements.push_back(LEFT);
    movements.push_back(RIGHT);
    movements.push_back(LEFT);
    movements.push_back(DOWN);
    movements.push_back(DOWN);

    moveRobotListMovements(map, movements);
    displayMap(map);

    return 0;
}

